unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, Math;

type
  TForm1 = class(TForm)
    P1: TPanel;
    Im1: TImage;
    PB1: TPaintBox;
    P2: TPanel;
    Clear: TButton;
    SpinEdit1: TSpinEdit;
    Teach: TButton;
    ImTest: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TeachClick(Sender: TObject);
    procedure Im2bin;
    procedure Debug(name:string;type_:integer);
    procedure Im1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Im1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Im1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ClearClick(Sender: TObject);
    procedure ImCompress;
    procedure ImTestClick(Sender: TObject);
    procedure Recognitize;
  private

  public
    Icon:array[1..16,1..16] of integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var a:array[0..9,1..16,1..16] of integer;
    IsDrawing:boolean;
    Icon:array[1..16,1..16] of integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SpinEdit1.Value:=8;
  memo1.Clear;
  Im1.Canvas.FillRect(Rect(0,0,128,128));
end;

procedure TForm1.TeachClick(Sender: TObject);
 var n,i,j:integer;
begin
  Im2bin;
end;

procedure TForm1.Im2bin;
var ImWidth,ImHeight,
    IconX,IconY,
    i,j,n,
    x,y,
    ImX,ImY:integer;
begin
  Application.ProcessMessages;
  {Clear TImage}
  Im1.Canvas.Brush.Color := clWhite;
  Im1.Canvas.FillRect(Rect(0,0,128,128));
  {End clear}
  for n:=0 to 9 do
  begin
    im1.Picture.LoadFromFile(ExtractfilePath(Application.ExeName)+'My\'+inttostr(n)+'.bmp');
    ImWidth:=im1.Picture.Width;
    ImHeight:=im1.Picture.Height;
    IconX:=Floor(ImWidth /16);
    IconY:=Floor(ImHeight/16);
    X:=0;
    Y:=0;
    for i:=1 to 16 do
    for j:=1 to 16 do
    begin
      for ImX:=X to X+IconX do
      for ImY:=Y to Y+IconY do
      Begin
        if im1.Canvas.Pixels[ImX,ImY]=clBlack then a[n,j,i]:=1
        else a[n,j,i]:=0;
      end;
      X:=X+IconX;
      if X>=ImWidth then
      Begin
        X:=0;
        Y:=Y+IconY;
      end;
    end;
  end;
  {Clear TImage}
  Im1.Canvas.Brush.Color := clWhite;
  Im1.Canvas.FillRect(Rect(0,0,128,128));
  {End clear}
  showmessage('Program Teach');
 // Debug('',1);
end;

procedure TForm1.Debug(name:string;type_:integer);
 var f:textfile;
     n,i,j:integer;
begin
  case type_ of
     {Saving compress binary image}
     1: begin
          for n:=0 to 9 do
          begin
            AssignFile(f,ExtractFilePath(Application.ExeName)+'debug\1\'+inttostr(n)+'.txt');
            Rewrite(f);
            for i:=1 to 16 do
            begin
              for j:=1 to 16 do
              begin
                write(f,a[n,j,i]);
              end;
              writeln(f,'');
            end;
            CloseFile(f);
          end;
          showmessage('Debug done!');
        end;
     {Saving User compress binary image}
     2: begin
          AssignFile(f,Name);
          Rewrite(f);
          for i:=1 to 16 do
            begin
              for j:=1 to 16 do
              begin
                write(f,Icon[j,i]);
              end;
              writeln(f,'');
            end;
          CloseFile(f);
        end;
  end;
end;

procedure TForm1.Im1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  IsDrawing := true;
  if (SpinEdit1.Value>=1) and (SpinEdit1.Value<=10) then Im1.Canvas.Pen.Width:=SpinEdit1.Value else
  Im1.Canvas.Pen.Width:=SpinEdit1.Value;
  Im1.Canvas.MoveTo(x,y);
end;

procedure TForm1.Im1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  IsDrawing := false;
end;

procedure TForm1.Im1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if  IsDrawing then
  begin
    Im1.Canvas.LineTo(x,y);
  end;
end;

procedure TForm1.ClearClick(Sender: TObject);
begin
  Im1.Canvas.Brush.Color := clWhite;
  Im1.Canvas.FillRect(Rect(0,0,128,128));
  
  label1.Caption:='';
end;

procedure TForm1.ImCompress;
 var ImWidth,ImHeight,
     IconX,IconY,
     i,j,
     x,y,
     ImX,ImY,kb:integer;
     Bmin:real;
begin
  ImWidth:=im1.Picture.Width;
  ImHeight:=im1.Picture.Height;
  PB1.Canvas.Brush.Style := bsSolid;
  PB1.Canvas.Rectangle(Rect(0,0,128,128));
  {**************************************}
  IconX:=Floor(ImWidth /16);
  IconY:=Floor(ImHeight/16);
  X:=0;
  Y:=0;
  BMin:=Round(((IconX*IconY)*50)/100);
  for i:=1 to 16 do
  for j:=1 to 16 do
  begin
    for ImX:=X to X+IconX do
    for ImY:=Y to Y+IconY do
    Begin
      if im1.Canvas.Pixels[ImX,ImY]=clBlack then inc(kb);
      if kb>=Bmin then
      begin
        Icon[j,i]:=1;
        PB1.Canvas.Brush.Color := clRed;
        PB1.Canvas.Brush.Style := bsSolid;
        PB1.Canvas.Rectangle(j * 8, i * 8, j * 8 + 8, i * 8 + 8);
      end
      else
      begin
        Icon[j,i]:=0;
        PB1.Canvas.Brush.Color :=clRed;
        PB1.Canvas.Brush.Style := bsClear;
        PB1.Canvas.Rectangle(j * 8, i * 8, j * 8 + 8, i * 8 + 8);
      end;
    end;
    kb:=0;
    X:=X+IconX;
    if X>=ImWidth then
    Begin
      X:=0;
      Y:=Y+IconY;
    end;
  end;
end;

procedure TForm1.ImTestClick(Sender: TObject);
begin
  memo1.Clear;
  ImCompress;
  Recognitize;
 // Debug('ImCompress',2);
end;

procedure TForm1.Recognitize;
var n,t,i,j,symbol:integer;
    out_:array[0..9] of real;
    max,min:real;
    k:array[0..9,1..16,1..16] of integer;
    kn:array[0..9] of integer;
begin
  for i := 0 to 9 do
  begin
    kn[i]:=0;
    out_[i] := 0;
  end;
  for n:=0 to 9 do
    begin
      for i:=1 to 16 do
      for j:=1 to 16 do
      begin
        k[n,i,j]:=a[n,i,j] * Icon[i,j];
        if k[n,i,j]=1 then inc(kn[n]);
      end;
      out_[n]:=kn[n];
    end;
  max := 0;
  symbol := 0;
  for i := 0 to 9 do
  begin
    if out_[i] > max then
     begin
       max := out_[i];
       symbol := i;
     end;
  end;
for i := 0 to 9 do
begin
 memo1.lines.add(inttostr(i)+'    '+floattostr(100-out_[i])+'%');
end;
Label1.Caption := IntToStr(symbol);
end;

end.
